### Virtual Method

# Gio File open_readwrite

since: 2.22

#### Declaration

    GFileIOStream*
    open_readwrite (
      GFile* file,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Opens an existing file for reading and writing. The result is a `GFileIOStream` that can be used to read and write the contents of the file.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

If the file does not exist, the `G_IO_ERROR_NOT_FOUND` error will be returned. If the file is a directory, the `G_IO_ERROR_IS_DIRECTORY` error will be returned. Other errors are possible too, and depend on what kind of filesystem the file is on. Note that in many non-local file cases read and write streams are not supported, so make sure you really need to do read and write streaming, rather than just opening for reading or writing.

Available since: 2.22

#### Parameters

`cancellable`

  Type: `GCancellable`

  A `GCancellable`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFileIOStream`

`GFileIOStream` or `NULL` on error. Free the returned object with g_object_unref().

The caller of the function takes ownership of the data, and is responsible for freeing it.